using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;

namespace GGC_Nested
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //

            InitializeComponent();

        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.Size = new System.Drawing.Size(462, 364);
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(479, 418);
            this.Controls.Add(this.gridGroupingControl1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }


        private void Form1_Load(object sender, System.EventArgs e)
        {
            DataTable parentTable = GetParentTable();

            this.gridGroupingControl1.DataSource = parentTable;
                     
            this.gridGroupingControl1.TableControlCurrentCellAcceptedChanges += new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellAcceptedChanges);
            this.gridGroupingControl1.TableControlCurrentCellMoved += new GridTableControlCurrentCellMovedEventHandler(gridGroupingControl1_TableControlCurrentCellMoved);
            this.gridGroupingControl1.TableControlDrawCellDisplayText += new GridTableControlDrawCellDisplayTextEventHandler(gridGroupingControl1_TableControlDrawCellDisplayText);  
        }

        void gridGroupingControl1_TableControlCurrentCellMoved(object sender, GridTableControlCurrentCellMovedEventArgs e)
        {
            if( e.TableControl.CurrentCell.MoveFromRowIndex != e.TableControl.CurrentCell.MoveToRowIndex )  
                CurrentRecordBuffer = new Hashtable();
        }

        void gridGroupingControl1_TableControlDrawCellDisplayText(object sender, GridTableControlDrawCellDisplayTextEventArgs e)
        {
            if (e.TableControl.CurrentCell.RowIndex == e.Inner.RowIndex)
            {
                GridTableCellStyleInfo style = e.Inner.Style as GridTableCellStyleInfo;
                if (style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.Record
                    && style.TableCellIdentity.Column != null  )
                {
                    string sCellValue = Convert.ToString( CurrentRecordBuffer[style.TableCellIdentity.Column.Name] );
                    if( sCellValue != "" )
                        e.Inner.DisplayText = sCellValue;  
                }
            }
        }

        Hashtable CurrentRecordBuffer = new Hashtable();
            
        void gridGroupingControl1_TableControlCurrentCellAcceptedChanges(object sender, GridTableControlCancelEventArgs e)
        {
            if (!CurrentRecordBuffer.Contains("Description"))
                CurrentRecordBuffer.Add("Description", 23);
            else
                CurrentRecordBuffer["Description"] = 23;
        }

        

        #region * DataSource *

        private int numberParentRows = 5;
        private int numberChildRows = 10;
        private DataTable GetParentTable()
        {
            DataTable dt = new DataTable("ParentTable");

            dt.Columns.Add(new DataColumn("Rank")); //lower case p
            dt.Columns.Add(new DataColumn("Way Reference"));
            dt.Columns.Add(new DataColumn("Description"));
            dt.Columns.Add(new DataColumn("Weekly Volume Sdg"));

            for (int i = 0; i < numberParentRows; ++i)
            {
                DataRow dr = dt.NewRow();
                dr[0] = i % 3;//.ToString();
                dr[1] = string.Format("Way Reference {0}", i);
                dr[2] = string.Format("desc{0}", i);
                dr[3] = string.Format("Weekly Volume Sdg{0}", i);
                dt.Rows.Add(dr);
            }

            return dt;
        }

        private DataTable GetChildTable()
        {
            DataTable dt = new DataTable("ChildTable");
            Random r = new Random();

            dt.Columns.Add(new DataColumn("childID")); //lower case c
            dt.Columns.Add(new DataColumn("Name"));
            dt.Columns.Add(new DataColumn("ParentID")); //upper case P

            for (int i = 0; i < numberChildRows; ++i)
            {
                DataRow dr = dt.NewRow();
                dr[0] = i.ToString();
                dr[1] = string.Format("ChildName {0}", i);
                dr[2] = (i % (numberParentRows)).ToString();
                dt.Rows.Add(dr);
            }

            return dt;
        }

        #endregion


    }
}
